/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IShortPeriodLongPeriod_$type } from "./IShortPeriodLongPeriod";
import { ChaikinOscillatorIndicatorStrategy } from "./ChaikinOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core/ES2015/type";
export class ChaikinOscillatorIndicator extends StrategyBasedIndicator {
    get_p4() {
        return new ChaikinOscillatorIndicatorStrategy();
    }
    get p4() {
        return this.get_p4();
    }
    get_qh() {
        return ChaikinOscillatorIndicator.$;
    }
    get qh() {
        return this.get_qh();
    }
    get shortPeriod() {
        return typeGetValue(this.c(ChaikinOscillatorIndicator.qq));
    }
    set shortPeriod(a) {
        this.h(ChaikinOscillatorIndicator.qq, a);
    }
    qc() {
        return this.shortPeriod;
    }
    get longPeriod() {
        return typeGetValue(this.c(ChaikinOscillatorIndicator.qp));
    }
    set longPeriod(a) {
        this.h(ChaikinOscillatorIndicator.qp, a);
    }
    p9() {
        return this.longPeriod;
    }
}
ChaikinOscillatorIndicator.$t = markType(ChaikinOscillatorIndicator, 'ChaikinOscillatorIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
ChaikinOscillatorIndicator.qq = StrategyBasedIndicator.qo(3, ChaikinOscillatorIndicator.$);
ChaikinOscillatorIndicator.qp = StrategyBasedIndicator.qk(10, ChaikinOscillatorIndicator.$);
//# sourceMappingURL=ChaikinOscillatorIndicator.js.map