/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { ChaikinVolatilityIndicatorStrategy } from "./ChaikinVolatilityIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core/ES2015/type";
export class ChaikinVolatilityIndicator extends StrategyBasedIndicator {
    get_p4() {
        return new ChaikinVolatilityIndicatorStrategy();
    }
    get p4() {
        return this.get_p4();
    }
    get_qh() {
        return ChaikinVolatilityIndicator.$;
    }
    get qh() {
        return this.get_qh();
    }
    get qp() {
        return typeGetValue(this.c(ChaikinVolatilityIndicator.qq));
    }
    set qp(a) {
        this.h(ChaikinVolatilityIndicator.qq, a);
    }
    qa() {
        return this.qp;
    }
    qj(a) {
        this.qp = a;
    }
}
ChaikinVolatilityIndicator.$t = markType(ChaikinVolatilityIndicator, 'ChaikinVolatilityIndicator', StrategyBasedIndicator.$);
ChaikinVolatilityIndicator.qq = StrategyBasedIndicator.qm(10, ChaikinVolatilityIndicator.$);
//# sourceMappingURL=ChaikinVolatilityIndicator.js.map