import { Brush } from "igniteui-angular-core/ES2015/Brush";
import { XYChart } from "./XYChart";
import { DomWrapper, EventArgs, IList, Type } from "igniteui-angular-core/ES2015/type";
import { IZoomSlider } from "igniteui-angular-core/ES2015/IZoomSlider";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { DataSeriesType } from "igniteui-angular-core/ES2015/DataSeriesType";
import { IDataSeriesAdapterRule } from "igniteui-angular-core/ES2015/IDataSeriesAdapterRule";
import { XamDataChart } from "./XamDataChart";
import { FinancialChartVolumeType } from "./FinancialChartVolumeType";
import { FinancialChartXAxisMode } from "./FinancialChartXAxisMode";
import { FinancialChartYAxisMode } from "./FinancialChartYAxisMode";
import { FinancialChartType } from "./FinancialChartType";
import { HorizontalAlignment } from "igniteui-angular-core/ES2015/HorizontalAlignment";
import { FinancialIndicatorTypeCollection } from "./FinancialIndicatorTypeCollection";
import { FinancialOverlayTypeCollection } from "./FinancialOverlayTypeCollection";
import { AxisLabelsLocation } from "./AxisLabelsLocation";
import { FinancialChartZoomSliderType } from "./FinancialChartZoomSliderType";
import { BrushCollection } from "igniteui-angular-core/ES2015/BrushCollection";
import { IndicatorDisplayTypeCollection } from "./IndicatorDisplayTypeCollection";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
import { CustomIndicatorNameCollection } from "./CustomIndicatorNameCollection";
import { IChartLegend } from "igniteui-angular-core/ES2015/IChartLegend";
import { ObservableCollection$1 } from "igniteui-angular-core/ES2015/ObservableCollection$1";
import { TemplatedHtmlControl } from "./TemplatedHtmlControl";
import { FinancialChartContext } from "./FinancialChartContext";
import { FinancialChartToolbarContext } from "./FinancialChartToolbarContext";
import { FinancialChartToolbarViewModel } from "./FinancialChartToolbarViewModel";
import { Series } from "./Series";
import { Axis } from "./Axis";
import { DataSeries } from "igniteui-angular-core/ES2015/DataSeries";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { TitleSettings } from "./TitleSettings";
import { FinancialChartCustomIndicatorArgs } from "./FinancialChartCustomIndicatorArgs";
import { FinancialChartTypePicker } from "./FinancialChartTypePicker";
import { FinancialChartIndicatorMenu } from "./FinancialChartIndicatorMenu";
import { TrendLineType } from "igniteui-angular-core/ES2015/TrendLineType";
import { FinancialChartToolbarVisualData } from "./FinancialChartToolbarVisualData";
import { FinancialChartRangeSelectorViewModel } from "./FinancialChartRangeSelectorViewModel";
import { FinancialChartRangeSelectorVisualData } from "./FinancialChartRangeSelectorVisualData";
export declare class FinancialChart extends XYChart {
    static $t: Type;
    protected g3(a: string, b: any, c: any): void;
    private v8(a, b);
    private v7(a, b);
    private v4(a, b);
    private wg();
    private qd;
    provideGrid(a: DomWrapper): void;
    onDocumentClick(a: Event): void;
    private su;
    private ss;
    private sp;
    private sr;
    private st;
    private sq;
    getContext(): FinancialChartContext;
    provideContainer(a: any): void;
    private wr(a, b, c);
    private w5(a, b);
    private vp();
    private w3(a, b);
    setGridRows(): void;
    protected gj(): void;
    private wn();
    private wo();
    private wx();
    private vo();
    private we();
    protected gg(a: XamDataChart): void;
    private w8(a);
    private xb();
    private w9(a);
    private xa(a);
    sc(): number;
    gr(source_: any, a: number, b: any): void;
    gs(source_: any, a: number, b: any): void;
    gq(source_: any): void;
    gu(source_: any, a: number, b: any, c: any): void;
    protected gm(a: Series, b: number): void;
    private pj;
    private pk;
    private tc;
    tj: any;
    private td;
    tk: any;
    private s9;
    tg: any;
    private te;
    tl: any;
    private tf;
    tm: any;
    private ta;
    th: any;
    private tb;
    ti: any;
    private q1;
    q2: IZoomSlider;
    protected get_cs(): number;
    protected set_cs(a: number): void;
    protected get_bq(): boolean;
    protected set_bq(a: boolean): void;
    private r5;
    sg: number;
    constructor();
    protected h7(): Axis;
    protected h8(): Axis;
    protected u(a: DataSeries): DataSeriesType;
    protected get_b5(): List$1<DataSeriesType>;
    protected readonly b5: List$1<DataSeriesType>;
    protected get_b4(): List$1<IDataSeriesAdapterRule>;
    protected readonly b4: List$1<IDataSeriesAdapterRule>;
    private o6(a);
    private qk(a);
    private o5(a);
    protected f3(): void;
    protected f1(a: Series, b: number): void;
    protected hh(a: DataSeries): void;
    protected hk(): void;
    private po(a);
    private pn(a);
    private px(a);
    private pq(a);
    private tu(a);
    private o7(axisType_);
    private ql(axisType_);
    private qr();
    private qs();
    private qq();
    private qt();
    private readonly q8;
    private p7;
    private readonly p8;
    private readonly rb;
    private p5;
    private readonly p6;
    private readonly q9;
    private p9;
    private readonly qa;
    private readonly ra;
    private qe;
    private readonly qf;
    protected aq(a: DataSeries, b: DataSeriesType): Series;
    protected hj(): void;
    protected m6(a: (arg1: Axis) => void, b: string): void;
    protected na(a: (arg1: Axis) => void, b: boolean): void;
    protected m8(a: (arg1: TitleSettings) => void): void;
    protected nc(a: (arg1: TitleSettings) => void): void;
    protected nb(a: (arg1: AxisLabelSettings) => void): void;
    protected m7(a: (arg1: AxisLabelSettings) => void): void;
    protected gf(a: XamDataChart): void;
    private static s7;
    private tn;
    private uo();
    private vy(a, b);
    private vl();
    private vm(a);
    private vq(a);
    private vt(a);
    private vr(a);
    private vs(a, b);
    private vu(a);
    private s1(a, b);
    protected f9(a: (arg1: Series, arg2: number) => void): void;
    private qx;
    private volumeChart;
    private wi();
    private rc(a);
    private rg(a);
    private rd(a);
    private rf(a);
    private wh();
    private qu(indicatorName_);
    private qw(a);
    private wz(a);
    dj(): any;
    ts(): string;
    private qv(overlayName_);
    private wy();
    private rl;
    private ww();
    protected gc(): void;
    protected get_bv(): boolean;
    protected readonly rp: boolean;
    private w4(a, b);
    private wj();
    protected gy(a: (arg1: XamDataChart) => void, b: boolean, c: string): void;
    private vw(a, b);
    private ws(a, b, c);
    private readonly ro;
    private vx(a, b);
    private rh(a, b);
    private wm();
    private v1(a, b);
    private v6(a, b);
    private v5(a, b);
    private vz(a, b);
    private v0(a, b);
    private wa(a, b);
    private wd(a);
    private wb(a);
    private vn();
    private wq(a, b);
    private w2(a, b);
    private v2(a, b);
    private w0();
    private rk;
    private v9(a, b);
    private vv(a, b);
    private wu(a, b, c, d);
    private wt(a);
    private wl(a);
    private v3(a, b);
    private w1();
    private wv();
    protected ho(a: Series, b: Series, c: DataSeries): void;
    protected m1(a: Axis): void;
    protected m3(a: Axis): void;
    private wc(a);
    protected gk(a: Series, b: number): void;
    protected g1(a: string, b: any, c: any): void;
    private q7;
    rn: boolean;
    private s0;
    s8: number;
    private r7;
    sk: number;
    private r9;
    sm: number;
    private r8;
    sl: number;
    private sa;
    sn: number;
    readonly sj: number;
    readonly si: number;
    private pp;
    pr: FinancialChartVolumeType;
    private ps;
    pt: FinancialChartXAxisMode;
    private pu;
    pv: FinancialChartYAxisMode;
    private q4;
    ri: boolean;
    private pl;
    pm: FinancialChartType;
    protected get_ni(): HorizontalAlignment;
    protected set_ni(a: HorizontalAlignment): void;
    private q5;
    rj: boolean;
    private pz;
    p0: FinancialIndicatorTypeCollection;
    private p1;
    p2: FinancialOverlayTypeCollection;
    private rr;
    private indicatorCharts;
    private q6;
    rm: boolean;
    protected get_cu(): number;
    protected set_cu(a: number): void;
    protected get_ie(): AxisLabelsLocation;
    protected set_ie(a: AxisLabelsLocation): void;
    private qy;
    zoomSliderChart: XamDataChart;
    private qj;
    private zoomSliderAxis;
    private o4;
    private zoomSliderXAxis;
    private pw;
    py: FinancialChartZoomSliderType;
    private on;
    ov: BrushCollection;
    private oo;
    ow: BrushCollection;
    private op;
    ox: BrushCollection;
    private oq;
    oy: BrushCollection;
    private os;
    o0: BrushCollection;
    private or;
    oz: BrushCollection;
    private om;
    ou: BrushCollection;
    private ol;
    ot: BrushCollection;
    private r6;
    sh: number;
    private r4;
    sf: number;
    private r3;
    se: number;
    private qb;
    qc: IndicatorDisplayTypeCollection;
    private sw;
    s3: number;
    private r2;
    sd: number;
    private sz;
    s6: number;
    private sx;
    s4: number;
    private sv;
    s2: number;
    private sy;
    s5: number;
    private pg;
    pi: FinancialChartRangeSelectorOptionCollection;
    ph: FinancialChartRangeSelectorOptionCollection;
    private pc;
    customIndicatorNames: CustomIndicatorNameCollection;
    applyCustomIndicators: (sender: any, e: FinancialChartCustomIndicatorArgs) => void;
    protected get_bw(): boolean;
    protected set_bw(a: boolean): void;
    private w6;
    w7: Brush;
    private sb;
    so: number;
    private q3;
    re: boolean;
    private p3;
    p4: IChartLegend;
    private o3;
    private xAxis;
    private qi;
    private yAxis;
    private qh;
    private volumeAxis;
    private o2;
    private volumeXAxis;
    private qg;
    private indicatorAxis;
    private o1;
    private indicatorXAxis;
    private rq;
    private rt;
    private rs;
    private rv;
    private rz;
    r1: Date;
    private ry;
    r0: Date;
    private rw;
    readonly xAxisBreaks: ObservableCollection$1<any>;
}
export declare class FinancialChartToolbar extends TemplatedHtmlControl {
    static $t: Type;
    bg(a: DomWrapper): void;
    bl(a: Event): void;
    private o;
    constructor(a: FinancialChart, b: any);
    private r;
    s: FinancialChartRangeSelector;
    private z;
    aa: FinancialChartTypePicker;
    private p;
    q: FinancialChartIndicatorMenu;
    private bm(a, b, c);
    private bh(a, b);
    private bi(a, b);
    private bj(a, b);
    w: FinancialChartToolbarViewModel;
    v(): FinancialChartToolbarContext;
    l(a: any): void;
    private bk();
    private aq;
    au: Date;
    private ap;
    at: Date;
    private ao;
    as: Date;
    private an;
    ar: Date;
    rangeChanged: (sender: any, e: EventArgs) => void;
    chartTypeChanged: (sender: any, e: EventArgs) => void;
    trendLineTypeChanged: (sender: any, e: EventArgs) => void;
    volumeTypeChanged: (sender: any, e: EventArgs) => void;
    indicatorTypesChanged: (sender: any, e: EventArgs) => void;
    overlayTypesChanged: (sender: any, e: EventArgs) => void;
    bn(): void;
    private x;
    y: FinancialChartType;
    private ah;
    ai: TrendLineType;
    private ab;
    ac: FinancialChartVolumeType;
    private ad;
    ae: FinancialIndicatorTypeCollection;
    private af;
    ag: FinancialOverlayTypeCollection;
    static am(a: IList, b: IList): boolean;
    aj(): FinancialChartToolbarVisualData;
    private t;
    u: FinancialChartRangeSelectorOptionCollection;
    private ak;
    al: boolean;
}
export declare class FinancialChartRangeSelector extends TemplatedHtmlControl {
    static $t: Type;
    private static x;
    q: FinancialChartRangeSelectorViewModel;
    v: Date;
    u: Date;
    t: Date;
    s: Date;
    ab(): void;
    constructor(a: any);
    l(a: any): void;
    private z();
    rangeChanged: (sender: any, e: EventArgs) => void;
    r(): FinancialChartRangeSelectorVisualData;
    o: FinancialChartRangeSelectorOptionCollection;
    private aa();
    private p;
}
