/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FinancialSeries } from "./FinancialSeries";
import { DependencyProperty } from "igniteui-angular-core/ES2015/DependencyProperty";
import { ISortingAxis_$type } from "./ISortingAxis";
import { Type, typeCast, markType } from "igniteui-angular-core/ES2015/type";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { ScalerParams } from "./ScalerParams";
import { AxisRange } from "./AxisRange";
import { PropertyMetadata } from "igniteui-angular-core/ES2015/PropertyMetadata";
import { isNaN_ } from "igniteui-angular-core/ES2015/number";
export class FinancialOverlay extends FinancialSeries {
    constructor() {
        super();
        this.pa = false;
        this.pa = false;
    }
    hs(a, b, c, d) {
        super.hs(a, b, c, d);
        if (this.l0 != null && typeCast(ISortingAxis_$type, this.l0) !== null) {
            this.l0.i$i();
        }
        this.mg.bu.e(this.er);
        this.pb();
        if (this.ml != null) {
            this.ml.ck();
        }
        this.i5(true);
    }
    get_du() {
        return true;
    }
    is(a, b, c, d) {
        switch (b) {
            case "FastItemsSource":
                this.pa = false;
                break;
            case FinancialOverlay.$$p[0]:
                this.pa = false;
                this.i5(false);
                this.ic();
                break;
            case "XAxis":
                this.pa = false;
                break;
        }
        super.is(a, b, c, d);
    }
    bd() {
        if (this.be == 0) {
            return 1;
        }
        else {
            return super.bd();
        }
    }
    dg(a, b) {
        if (this.df(a, b)) {
            return true;
        }
        return false;
    }
    ac() {
        super.ac();
        this.i5(false);
    }
    c8(a) {
        let b = this.bz != null ? this.bz.indexOf(a) : -1;
        let c = this.bi.bs;
        c = c.copy();
        let d = this.bi.br;
        let e = new Rect(0, 0, 0, 1, 1);
        let f = this.lk(this.bi);
        let g = new ScalerParams(0, e, e, this.l0.b8, f);
        let h = new ScalerParams(0, e, e, this.ml.b8, f);
        h.b = this.ee();
        if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
            if (this.l0 != null) {
                let i = this.l0.dt(b, g);
                if (i < c.left + 0.1 * c.width) {
                    i = i + 0.4 * c.width;
                }
                if (i > c.right - 0.1 * c.width) {
                    i = i - 0.4 * c.width;
                }
                c.x = i - 0.5 * c.width;
            }
            if (this.ml != null && this.ms != null && this.mq != null && b < this.ms.count && b < this.mq.count) {
                let j = this.ml.dt(this.ms.item(b), h);
                let k = this.ml.dt(this.mq.item(b), h);
                if (!isNaN_(j) && !isNaN_(k)) {
                    let l = Math.abs(j - k);
                    if (c.height < l) {
                        c.height = l;
                        c.y = Math.min(j, k);
                    }
                    else {
                        if (j < c.top + 0.1 * c.height) {
                            j = j + 0.4 * c.height;
                        }
                        if (j > c.bottom - 0.1 * c.height) {
                            j = j - 0.4 * c.height;
                        }
                        c.y = j - 0.5 * c.height;
                    }
                }
            }
            this.bn.ap(this.bs, c, true);
        }
        return b >= 0;
    }
    an(a) {
        if (a != null && a == this.ml && this.ms != null && this.mq != null) {
            return new AxisRange(this.ms.minimum, this.mq.maximum);
        }
        return null;
    }
}
FinancialOverlay.$t = markType(FinancialOverlay, 'FinancialOverlay', FinancialSeries.$);
Type.dep(DependencyProperty, PropertyMetadata, FinancialOverlay, 'raisePropertyChanged', ['IgnoreFirst:pc:pe', [1, 0]]);
//# sourceMappingURL=FinancialOverlay.js.map