/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { ForceIndexIndicatorStrategy } from "./ForceIndexIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core/ES2015/type";
export class ForceIndexIndicator extends StrategyBasedIndicator {
    constructor() {
        super();
        this.pc = 1;
    }
    get_p4() {
        return new ForceIndexIndicatorStrategy();
    }
    get p4() {
        return this.get_p4();
    }
    get_qh() {
        return ForceIndexIndicator.$;
    }
    get qh() {
        return this.get_qh();
    }
    get qp() {
        return typeGetValue(this.c(ForceIndexIndicator.qq));
    }
    set qp(a) {
        this.h(ForceIndexIndicator.qq, a);
    }
    qa() {
        return this.qp;
    }
    qj(a) {
        this.qp = a;
    }
}
ForceIndexIndicator.$t = markType(ForceIndexIndicator, 'ForceIndexIndicator', StrategyBasedIndicator.$);
ForceIndexIndicator.qq = StrategyBasedIndicator.qm(0, ForceIndexIndicator.$);
//# sourceMappingURL=ForceIndexIndicator.js.map