import { ScatterTriangulationSeries } from "./ScatterTriangulationSeries";
import { ColorScale } from "./ColorScale";
import { Type, Point } from "igniteui-angular-core/ES2015/type";
import { IFastItemColumn$1 } from "igniteui-angular-core/ES2015/IFastItemColumn$1";
import { Color } from "igniteui-angular-core/ES2015/Color";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { RenderSurface } from "./RenderSurface";
import { SeriesView } from "./SeriesView";
import { WriteableBitmap } from "igniteui-angular-core/ES2015/WriteableBitmap";
import { TriangleRasterizer } from "./TriangleRasterizer";
import { ScalerParams } from "./ScalerParams";
import { ObservableColorCollection } from "igniteui-angular-core/ES2015/ObservableColorCollection";
import { RenderingContext } from "igniteui-angular-core/ES2015/RenderingContext";
export declare class ScatterAreaSeries extends ScatterTriangulationSeries {
    static $t: Type;
    constructor();
    private nc;
    nd: ColorScale;
    private nq(a, b);
    nl: string;
    private nh;
    private ni;
    protected get_dp(): boolean;
    protected set_dp(a: boolean): void;
    protected is(a: any, b: string, c: any, d: any): void;
    i6(a: boolean): void;
    i4(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    protected nr(a: SeriesView): void;
    private no(a);
    fm(a: Point): any;
    protected na: number[];
    protected nb: number[];
    ng(a: SeriesView, b: ScalerParams, c: ScalerParams): TriangleRasterizer;
    m9: Color[];
    protected nj(): ObservableColorCollection;
    protected ne(): ColorScale;
    hp(a: boolean, b: SeriesView): void;
    protected bf(): SeriesView;
    im(a: SeriesView): void;
    nf: ScatterAreaSeriesView;
    np(a: any): void;
    static $$p: string[];
}
export declare class ScatterAreaSeriesView extends SeriesView {
    static $t: Type;
    private by;
    private bu;
    bx: number[];
    constructor(a: ScatterAreaSeries);
    b7(a: number, b: number): void;
    b3(a: any): void;
    private b2;
    private b1;
    private b0;
    bv(): number[];
    bw(a: boolean): number[];
    private b6();
    bz(a: Rect, b: ColorScale, c: IFastItemColumn$1<number>): TriangleRasterizer;
    b5(a: TriangleRasterizer): void;
    b4(): void;
    protected a3(a: RenderingContext, b: boolean): void;
    b8(a: WriteableBitmap): void;
    ai(a: any): void;
    getDefaultTooltipTemplate(): string;
}
