import { AnchoredCategorySeries } from "./AnchoredCategorySeries";
import { NumericXAxis } from "./NumericXAxis";
import { CategoryYAxis } from "./CategoryYAxis";
import { IVerticalAnchoredCategorySeriesInteractionManager } from "./IVerticalAnchoredCategorySeriesInteractionManager";
import { Type, Point } from "igniteui-angular-core/ES2015/type";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericAxisBase } from "./NumericAxisBase";
import { Axis } from "./Axis";
import { ScalerParams } from "./ScalerParams";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
export declare abstract class VerticalAnchoredCategorySeries extends AnchoredCategorySeries {
    static $t: Type;
    xAxis: NumericXAxis;
    yAxis: CategoryYAxis;
    hn(): void;
    private pr;
    readonly ps: IVerticalAnchoredCategorySeriesInteractionManager;
    protected get_isVertical(): boolean;
    my(): CategoryAxisBase;
    ni(): NumericAxisBase;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    e9(a: Point, b: boolean): number;
    fb(a: Point, b: boolean): number;
    d6(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    protected bd(): SeriesHitTestMode;
    lo(a: Point): Rect;
    private p0(a);
    dg(a: Point, b: boolean): boolean;
    ek(a: Point, b: boolean, c: boolean): number;
    ld(a: Point, b: boolean, c: boolean): Point;
    fetchXAxis(): Axis;
    fetchYAxis(): Axis;
    o8(a: Axis): void;
    o9(a: Axis): void;
    nt(): boolean;
    ms(a: number, b: number): any[];
    d8(a: Point): number;
    nx(a: Point): number;
    e5(a: Point): number;
    fm(a: Point): any;
    protected is(a: any, b: string, c: any, d: any): void;
    pv(a: any): boolean;
    pu(a: any): boolean;
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
}
