import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxStackedBarSeriesComponent } from "./igx-stacked-bar-series-component";
import { IgxVerticalStackedSeriesBaseComponent } from "./igx-vertical-stacked-series-base-component";
import { IgxStackedSeriesBaseComponent } from "./igx-stacked-series-base-component";
import { IgxCategorySeriesComponent } from "./igx-category-series-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { Stacked100BarSeries } from "./Stacked100BarSeries";
/**
 * Represents a IgxDataChartComponent stacked100 bar series.
*/
export const IgxStacked100BarSeriesComponent_PROVIDERS = [{ provide: IgxStackedBarSeriesComponent, useExisting: forwardRef(() => IgxStacked100BarSeriesComponent) }, { provide: IgxVerticalStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100BarSeriesComponent) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100BarSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStacked100BarSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStacked100BarSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStacked100BarSeriesComponent) }];
export class IgxStacked100BarSeriesComponent extends IgxStackedBarSeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new Stacked100BarSeries();
    }
    get i() {
        return this._implementation;
    }
}
IgxStacked100BarSeriesComponent.decorators = [
    { type: Component, args: [{
                selector: 'igx-stacked-100-bar-series',
                template: ``,
                providers: [{ provide: IgxStackedBarSeriesComponent, useExisting: forwardRef(() => IgxStacked100BarSeriesComponent) }, { provide: IgxVerticalStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100BarSeriesComponent) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100BarSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStacked100BarSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStacked100BarSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStacked100BarSeriesComponent) }],
                changeDetection: ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
IgxStacked100BarSeriesComponent.ctorParameters = () => [];
//# sourceMappingURL=igx-stacked-100-bar-series-component.js.map