import { Series } from "./Series";
import { Point, Type } from "igniteui-angular-core/ES5/type";
import { Frame } from "./Frame";
import { SeriesView } from "./SeriesView";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { NotifyCollectionChangedEventArgs } from "igniteui-angular-core/ES5/NotifyCollectionChangedEventArgs";
import { Axis } from "./Axis";
import { Brush } from "igniteui-angular-core/ES5/Brush";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { Tuple$2 } from "igniteui-angular-core/ES5/Tuple$2";
export declare abstract class AnnotationLayer extends Series {
    static $t: Type;
    constructor();
    protected bf(): SeriesView;
    im(a: SeriesView): void;
    protected ly(a: Series): boolean;
    protected ls: AnnotationLayerView;
    l0: boolean;
    l1: boolean;
    ms: Point;
    lx: boolean;
    protected get_cm(): boolean;
    protected bd(): SeriesHitTestMode;
    protected get_cw(): boolean;
    protected get_isUsableInLegend(): boolean;
    protected is(a: any, b: string, c: any, d: any): void;
    protected mt: Point;
    private mk(a);
    private mj(a);
    private mf(a);
    private me(a);
    private l8(a, b);
    private mi(a, b);
    protected ma(a: Axis, b: boolean): void;
    protected mb(a: Series, b: boolean): void;
    private mh(a, b);
    private l7(a, b);
    protected mp(): Brush;
    protected mq(): Brush;
    protected l9(a: NotifyCollectionChangedEventArgs): void;
    protected mc(a: NotifyCollectionChangedEventArgs): void;
    protected lu: Frame;
    protected lt: Frame;
    protected lv: Frame;
    protected jl(a: Rect, b: Rect): void;
    protected jk(a: Rect, b: Rect): void;
    i6(a: boolean): void;
    protected get_cj(): boolean;
    protected md(a: Frame, b: SeriesView): void;
    protected mg(a: Frame, b: SeriesView): void;
    protected l6(a: Series): Tuple$2<boolean, Point>;
    protected ih(a: Point): void;
    mr: Point;
    dv(a: Rect, b: Rect, c: SeriesView): boolean;
    protected get_dr(): boolean;
    private lw;
    lz: boolean;
    static $$p: string[];
}
export declare class AnnotationLayerView extends SeriesView {
    static $t: Type;
    constructor(a: AnnotationLayer);
    protected bu: AnnotationLayer;
    private bv;
    private bw;
    private b0();
    bx(): void;
    bz(): void;
    by(): void;
}
