/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { AnchoredCategorySeries } from "./AnchoredCategorySeries";
import { IHorizontalAnchoredCategorySeriesInteractionManager_$type } from "./IHorizontalAnchoredCategorySeriesInteractionManager";
import { DVContainer } from "igniteui-angular-core/ES5/DVContainer";
import { Type, runOn, Point_$type, typeCast, EnumUtil, enumGetBox, markType } from "igniteui-angular-core/ES5/type";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "igniteui-angular-core/ES5/DependencyProperty";
import { NumericYAxis } from "./NumericYAxis";
import { CategoryMode_$type } from "./CategoryMode";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { ScalerParams } from "./ScalerParams";
import { Axis } from "./Axis";
import { TrendLineType_$type } from "igniteui-angular-core/ES5/TrendLineType";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { ISortingAxis_$type } from "./ISortingAxis";
import { CategoryXAxis } from "./CategoryXAxis";
import { PropertyMetadata } from "igniteui-angular-core/ES5/PropertyMetadata";
var HorizontalAnchoredCategorySeries = /** @class */ (function (_super) {
    tslib_1.__extends(HorizontalAnchoredCategorySeries, _super);
    function HorizontalAnchoredCategorySeries() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.pu = null;
        _this.pq = null;
        _this.pw = null;
        _this.ps = 0;
        return _this;
    }
    Object.defineProperty(HorizontalAnchoredCategorySeries.prototype, "pv", {
        get: function () {
            var _this = this;
            if (this.pu == null) {
                this.pu = DVContainer.instance.createInstance(IHorizontalAnchoredCategorySeriesInteractionManager_$type, function () { return _this.b2.n; });
            }
            return this.pu;
        },
        enumerable: true,
        configurable: true
    });
    HorizontalAnchoredCategorySeries.prototype.hn = function () {
        _super.prototype.hn.call(this);
        this.xAxis = null;
        this.yAxis = null;
    };
    HorizontalAnchoredCategorySeries.prototype.bd = function () {
        if (this.be == 0) {
            return 1;
        }
        else {
            return _super.prototype.bd.call(this);
        }
    };
    HorizontalAnchoredCategorySeries.prototype.my = function () {
        return this.pq;
    };
    HorizontalAnchoredCategorySeries.prototype.ni = function () {
        return this.pw;
    };
    HorizontalAnchoredCategorySeries.prototype.lo = function (a) {
        if (this.mz == null || this.mz.m.count == 0 || !this.hasMarkers || !this.lv()) {
            return Rect.empty;
        }
        return this.pv.d$d(this, this.mz.m, a, runOn(this, this.p8));
    };
    HorizontalAnchoredCategorySeries.prototype.p8 = function (a) {
        return this.oq.c5(a);
    };
    HorizontalAnchoredCategorySeries.prototype.p0 = function (a, b, c) {
        return this.pv.d$c(this, this.ni(), a, b, c);
    };
    HorizontalAnchoredCategorySeries.prototype.ah = function (a) {
        return this.pv.d$a(this, this.mz.f, this.nz(this.bi), this.n0(this.bi), a);
    };
    HorizontalAnchoredCategorySeries.prototype.ai = function (a) {
        return this.pv.d$b(this, this.mz.f, this.nz(this.bi), this.n0(this.bi), a);
    };
    HorizontalAnchoredCategorySeries.prototype.dg = function (a, b) {
        if (this.df(a, b)) {
            return true;
        }
        if (this.lw(a, b)) {
            return true;
        }
        return false;
    };
    HorizontalAnchoredCategorySeries.prototype.getOffsetValue = function () {
        return this.m3.r(this.my(), this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    HorizontalAnchoredCategorySeries.prototype.getCategoryWidth = function () {
        var a = this.getEffectiveViewport1(this.bi);
        return this.my().getCategorySize(this.bi.bs, this.bi.br, a);
    };
    HorizontalAnchoredCategorySeries.prototype.ek = function (a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.bi);
        var e = this.my();
        var f = new ScalerParams(0, this.bs.mn, this.bi.br, e.b8, d);
        var g = this.m3.r(e, this.bs.mn, this.bi.br, d);
        return this.em(this.valueColumn, a, e, f, g, runOn(this, this.nx), b, c);
    };
    HorizontalAnchoredCategorySeries.prototype.fb = function (a, b) {
        return this.fc(a, b, this.my(), runOn(this, this.nx), this.valueColumn);
    };
    HorizontalAnchoredCategorySeries.prototype.e9 = function (a, b) {
        return this.fa(a, b, this.my(), runOn(this, this.nx), this.valueColumn);
    };
    HorizontalAnchoredCategorySeries.prototype.d6 = function (a, b, c, d, e) {
        if (this.valueColumn == null) {
            return Number.POSITIVE_INFINITY;
        }
        return this.d7(a, b, this.my(), d, e, this.valueColumn.count, runOn(this, this.nx));
    };
    HorizontalAnchoredCategorySeries.prototype.ld = function (a, b, c) {
        if (this.my() == null || this.ni() == null) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        return this.lf(a, b, c, this.m3.r(this.my(), this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.ni(), this.my(), null, null, null);
    };
    HorizontalAnchoredCategorySeries.prototype.fetchXAxis = function () {
        return this.pq;
    };
    HorizontalAnchoredCategorySeries.prototype.fetchYAxis = function () {
        return this.pw;
    };
    HorizontalAnchoredCategorySeries.prototype.o8 = function (a) {
        this.xAxis = typeCast(CategoryAxisBase.$, a);
    };
    HorizontalAnchoredCategorySeries.prototype.o9 = function (a) {
        this.yAxis = typeCast(NumericYAxis.$, a);
    };
    HorizontalAnchoredCategorySeries.prototype.nt = function () {
        return this.pw != null && this.pw.ck();
    };
    HorizontalAnchoredCategorySeries.prototype.p4 = function (a) {
        this.pq = a;
    };
    HorizontalAnchoredCategorySeries.prototype.p5 = function (a) {
        this.pw = a;
    };
    HorizontalAnchoredCategorySeries.prototype.ms = function (a, b) {
        return this.on(a, b, this.pq);
    };
    HorizontalAnchoredCategorySeries.prototype.is = function (a, b, c, d) {
        switch (b) {
            case HorizontalAnchoredCategorySeries.$$p[0]:
                this.p4(this.xAxis);
                if (this.oq.cz) {
                    this.oq.cy = CategoryTrendLineManagerFactory.a(this.oq.cy, this.pq, this.jp, this, this.b2);
                }
                break;
            case "TrendLineType":
                var e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                if (e != 0) {
                    this.oq.cy = CategoryTrendLineManagerFactory.a(this.oq.cy, this.pq, this.jp, this, this.b2);
                }
                break;
        }
        _super.prototype.is.call(this, a, b, c, d);
        switch (b) {
            case HorizontalAnchoredCategorySeries.$$p[0]:
                if (c != d) {
                    this.ht(typeCast(Axis.$, c));
                    this.ix(typeCast(Axis.$, d));
                    this.p4(this.xAxis);
                    this.m7.cn.g(this.er);
                    this.i5(false);
                    this.ic();
                }
                break;
            case HorizontalAnchoredCategorySeries.$$p[1]:
                if (c != d) {
                    this.ht(typeCast(Axis.$, c));
                    this.ix(typeCast(Axis.$, d));
                    this.p5(this.yAxis);
                    this.m7.cn.g(this.er);
                    this.nt();
                    this.i5(false);
                    this.ic();
                }
                break;
            case "CategoryMode":
                if (this.xAxis != null) {
                    this.xAxis.kg(true);
                }
                break;
        }
    };
    HorizontalAnchoredCategorySeries.prototype.hs = function (a, b, c, d) {
        _super.prototype.hs.call(this, a, b, c, d);
        if (this.pq != null && typeCast(ISortingAxis_$type, this.pq) !== null) {
            this.pq.i$i();
        }
        switch (a) {
            case 4:
                if (this.pq != null) {
                    this.pq.ck();
                }
                if (this.pw != null && !this.pw.ck()) {
                    this.i5(true);
                }
                break;
            case 1:
                if (this.pq != null) {
                    this.pq.ck();
                }
                if (this.pw != null && !this.pw.ck()) {
                    this.i5(true);
                }
                break;
            case 0:
                if (this.pq != null) {
                    this.pq.ck();
                }
                if (this.pw != null && !this.pw.ck()) {
                    this.i5(true);
                }
                break;
            case 2:
                if (this.o1 != null && this.oq.cn.d > 0 && this.pw != null && !this.pw.ck()) {
                    this.i5(true);
                }
                break;
            case 3:
                if (d == this.o1) {
                    if (this.pq != null) {
                        this.pq.ck();
                    }
                    if (this.pw != null && !this.pw.ck()) {
                        this.i5(true);
                    }
                }
                break;
        }
    };
    HorizontalAnchoredCategorySeries.prototype.py = function (a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.b5) {
            return true;
        }
        return false;
    };
    HorizontalAnchoredCategorySeries.prototype.pz = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    Object.defineProperty(HorizontalAnchoredCategorySeries.prototype, "pt", {
        get: function () {
            return this.ps;
        },
        set: function (a) {
            var b = this.pt;
            if (a != b) {
                this.ps = a;
                this.raisePropertyChanged("CategoryMode", enumGetBox(CategoryMode_$type, b), enumGetBox(CategoryMode_$type, this.pt));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HorizontalAnchoredCategorySeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.nu;
        },
        enumerable: true,
        configurable: true
    });
    HorizontalAnchoredCategorySeries.$t = markType(HorizontalAnchoredCategorySeries, 'HorizontalAnchoredCategorySeries', AnchoredCategorySeries.$);
    return HorizontalAnchoredCategorySeries;
}(AnchoredCategorySeries));
export { HorizontalAnchoredCategorySeries };
Type.dep(DependencyProperty, PropertyMetadata, HorizontalAnchoredCategorySeries, 'raisePropertyChanged', ['XAxis::p6', [CategoryAxisBase.$, null], 'YAxis::p7', [NumericYAxis.$, null]]);
//# sourceMappingURL=HorizontalAnchoredCategorySeries.js.map