import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { CategoryMode } from "./CategoryMode";
import { SeriesView } from "./SeriesView";
import { Type, IList$1 } from "igniteui-angular-core/ES5/type";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { CategoryFrame } from "./CategoryFrame";
import { List$1 } from "igniteui-angular-core/ES5/List$1";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { CategorySeriesView } from "./CategorySeriesView";
import { Path } from "igniteui-angular-core/ES5/Path";
import { PointCollection } from "igniteui-angular-core/ES5/PointCollection";
import { UnknownValuePlotting } from "igniteui-angular-core/ES5/UnknownValuePlotting";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { Clipper } from "igniteui-angular-core/ES5/Clipper";
import { RenderingContext } from "igniteui-angular-core/ES5/RenderingContext";
export declare class StepAreaSeries extends HorizontalAnchoredCategorySeries implements IIsCategoryBased {
    static $t: Type;
    protected bf(): SeriesView;
    getHostReferenceValue(): number;
    im(a: SeriesView): void;
    qa: StepAreaSeriesView;
    protected get_ck(): boolean;
    constructor();
    p9: CategoryLineRasterizer;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    hp(a: boolean, b: SeriesView): void;
    private qb(a, b, c, d, e);
    protected m8(): CategoryTransitionInMode;
    ec(a: number, b: IList$1<number>, c: number, d: number, e: number, f: number, g: number, h: boolean): number;
    protected bd(): SeriesHitTestMode;
    og(a: CategoryFrame, b: CategorySeriesView): void;
    readonly currentCategoryMode: CategoryMode;
    readonly useHighMarkerFidelity: boolean;
}
export declare class StepAreaSeriesView extends AnchoredCategorySeriesView {
    static $t: Type;
    protected c6: StepAreaSeries;
    constructor(a: StepAreaSeries);
    ap(): void;
    private de;
    private di;
    private dg;
    private dk;
    readonly df: Path;
    readonly dj: Path;
    readonly dh: Path;
    readonly dl: Path;
    c7(): void;
    c8(a: number, b: List$1<number[]>, c: boolean, d: number, e: number, f: (arg1: PointCollection, arg2: PointCollection, arg3: PointCollection, arg4: PointCollection, arg5: boolean) => void, g: UnknownValuePlotting): void;
    c9(a: number, b: List$1<number[]>, c: boolean, d: number, e: number, f: (arg1: PointCollection, arg2: PointCollection, arg3: PointCollection, arg4: PointCollection, arg5: boolean) => void, g: UnknownValuePlotting, h: Clipper): void;
    private da;
    private dc;
    private db;
    private dd;
    protected a9(): void;
    protected a3(a: RenderingContext, b: boolean): void;
    ai(a: any): void;
}
