import { fromPoint } from "igniteui-angular-core/ES5/componentUtil";
/**
 * EventArgs class holding information about the dimensions of a hole in a doughnut chart.
*/
var /**
 * EventArgs class holding information about the dimensions of a hole in a doughnut chart.
*/
HoleDimensionsChangedEventArgs = /** @class */ (function () {
    function HoleDimensionsChangedEventArgs() {
    }
    Object.defineProperty(HoleDimensionsChangedEventArgs.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    HoleDimensionsChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    HoleDimensionsChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(HoleDimensionsChangedEventArgs.prototype, "center", {
        /**
         * The center point of the hole.
        */
        get: /**
             * The center point of the hole.
            */
        function () {
            return fromPoint(this.i.center);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HoleDimensionsChangedEventArgs.prototype, "radius", {
        /**
         * The radius of the hole.
        */
        get: /**
             * The radius of the hole.
            */
        function () {
            return this.i.radius;
        },
        enumerable: true,
        configurable: true
    });
    return HoleDimensionsChangedEventArgs;
}());
/**
 * EventArgs class holding information about the dimensions of a hole in a doughnut chart.
*/
export { HoleDimensionsChangedEventArgs };
//# sourceMappingURL=igx-hole-dimensions-changed-event-args.js.map