import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxPolarLineSeriesBaseComponent } from "./igx-polar-line-series-base-component";
import { IgxPolarBaseComponent } from "./igx-polar-base-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { PolarSplineSeries } from "./PolarSplineSeries";
/**
 * Represents a IgxDataChartComponent polar spline series.
*/
export var IgxPolarSplineSeriesComponent_PROVIDERS = [{ provide: IgxPolarLineSeriesBaseComponent, useExisting: forwardRef(function () { return IgxPolarSplineSeriesComponent; }) }, { provide: IgxPolarBaseComponent, useExisting: forwardRef(function () { return IgxPolarSplineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxPolarSplineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxPolarSplineSeriesComponent; }) }];
var IgxPolarSplineSeriesComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxPolarSplineSeriesComponent, _super);
    function IgxPolarSplineSeriesComponent() {
        return _super.call(this) || this;
    }
    IgxPolarSplineSeriesComponent.prototype.createImplementation = function () {
        return new PolarSplineSeries();
    };
    Object.defineProperty(IgxPolarSplineSeriesComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPolarSplineSeriesComponent.prototype, "stiffness", {
        /**
         * Gets or sets the Stiffness property.
        */
        get: /**
             * Gets or sets the Stiffness property.
            */
        function () {
            return this.i.o6;
        },
        set: function (v) {
            this.i.o6 = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgxPolarSplineSeriesComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-polar-spline-series',
                    template: "",
                    providers: [{ provide: IgxPolarLineSeriesBaseComponent, useExisting: forwardRef(function () { return IgxPolarSplineSeriesComponent; }) }, { provide: IgxPolarBaseComponent, useExisting: forwardRef(function () { return IgxPolarSplineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxPolarSplineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxPolarSplineSeriesComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxPolarSplineSeriesComponent.ctorParameters = function () { return []; };
    IgxPolarSplineSeriesComponent.propDecorators = {
        "stiffness": [{ type: Input },],
    };
    return IgxPolarSplineSeriesComponent;
}(IgxPolarLineSeriesBaseComponent));
export { IgxPolarSplineSeriesComponent };
//# sourceMappingURL=igx-polar-spline-series-component.js.map