/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { FullStochasticOscillatorIndicatorStrategy } from "./FullStochasticOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core/ES2015/type";
import { Brush } from "igniteui-angular-core/ES2015/Brush";
export class FullStochasticOscillatorIndicator extends StrategyBasedIndicator {
    constructor() {
        super();
        this.trendLineBrush = ((() => {
            let $ret = new Brush();
            $ret.fill = "#565656";
            return $ret;
        })());
        this.trendLineType = 10;
        this.trendLinePeriod = 3;
    }
    get_p4() {
        return new FullStochasticOscillatorIndicatorStrategy();
    }
    get p4() {
        return this.get_p4();
    }
    get_qh() {
        return FullStochasticOscillatorIndicator.$;
    }
    get qh() {
        return this.get_qh();
    }
    get qp() {
        return typeGetValue(this.c(FullStochasticOscillatorIndicator.qu));
    }
    set qp(a) {
        this.h(FullStochasticOscillatorIndicator.qu, a);
    }
    qa() {
        return this.qp;
    }
    qj(a) {
        this.qp = a;
    }
    get smoothingPeriod() {
        return typeGetValue(this.c(FullStochasticOscillatorIndicator.qv));
    }
    set smoothingPeriod(a) {
        this.h(FullStochasticOscillatorIndicator.qv, a);
    }
    qc() {
        return this.smoothingPeriod;
    }
    get qr() {
        return typeGetValue(this.c(FullStochasticOscillatorIndicator.qw));
    }
    set qr(a) {
        this.h(FullStochasticOscillatorIndicator.qw, a);
    }
    p9() {
        return this.qr;
    }
    pk() {
        return this.qr;
    }
}
FullStochasticOscillatorIndicator.$t = markType(FullStochasticOscillatorIndicator, 'FullStochasticOscillatorIndicator', StrategyBasedIndicator.$);
FullStochasticOscillatorIndicator.qu = StrategyBasedIndicator.qm(14, FullStochasticOscillatorIndicator.$);
FullStochasticOscillatorIndicator.qv = StrategyBasedIndicator.qn(3, FullStochasticOscillatorIndicator.$, "SmoothingPeriod");
FullStochasticOscillatorIndicator.qw = StrategyBasedIndicator.qn(3, FullStochasticOscillatorIndicator.$, "TriggerPeriod");
//# sourceMappingURL=FullStochasticOscillatorIndicator.js.map