import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { CategoryMode } from "./CategoryMode";
import { SeriesView } from "./SeriesView";
import { Type, IList$1 } from "igniteui-angular-core/ES2015/type";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { CategoryFrame } from "./CategoryFrame";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { CategorySeriesView } from "./CategorySeriesView";
import { Path } from "igniteui-angular-core/ES2015/Path";
import { UnknownValuePlotting } from "igniteui-angular-core/ES2015/UnknownValuePlotting";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { Clipper } from "igniteui-angular-core/ES2015/Clipper";
import { RenderingContext } from "igniteui-angular-core/ES2015/RenderingContext";
export declare class StepLineSeries extends HorizontalAnchoredCategorySeries implements IIsCategoryBased {
    static $t: Type;
    protected bf(): SeriesView;
    getHostReferenceValue(): number;
    im(a: SeriesView): void;
    qa: StepLineSeriesView;
    constructor();
    p9: CategoryLineRasterizer;
    ac(): void;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    protected get_ck(): boolean;
    hp(a: boolean, b: SeriesView): void;
    protected bd(): SeriesHitTestMode;
    ec(a: number, b: IList$1<number>, c: number, d: number, e: number, f: number, g: number, h: boolean): number;
    private qb(a, b, c, d, e, f);
    og(a: CategoryFrame, b: CategorySeriesView): void;
    readonly currentCategoryMode: CategoryMode;
    readonly useHighMarkerFidelity: boolean;
}
export declare class StepLineSeriesView extends AnchoredCategorySeriesView {
    static $t: Type;
    protected c6: StepLineSeries;
    constructor(a: StepLineSeries);
    private dg;
    private df;
    private dh;
    readonly dd: Path;
    readonly de: Path;
    readonly dc: Path;
    c7(): void;
    c8(a: number, b: List$1<number[]>, c: boolean, d: UnknownValuePlotting, e: Clipper, f: number, g: number): void;
    private db;
    private da;
    private c9;
    protected a9(): void;
    protected a3(a: RenderingContext, b: boolean): void;
    ai(a: any): void;
    protected ac(): void;
}
