import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxPolarBaseComponent } from "./igx-polar-base-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { PolarScatterSeries } from "./PolarScatterSeries";
/**
 * Represents a IgxDataChartComponent polar scatter series.
*/
export const IgxPolarScatterSeriesComponent_PROVIDERS = [{ provide: IgxPolarBaseComponent, useExisting: forwardRef(() => IgxPolarScatterSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxPolarScatterSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPolarScatterSeriesComponent) }];
export class IgxPolarScatterSeriesComponent extends IgxPolarBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new PolarScatterSeries();
    }
    get i() {
        return this._implementation;
    }
}
IgxPolarScatterSeriesComponent.decorators = [
    { type: Component, args: [{
                selector: 'igx-polar-scatter-series',
                template: ``,
                providers: [{ provide: IgxPolarBaseComponent, useExisting: forwardRef(() => IgxPolarScatterSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxPolarScatterSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPolarScatterSeriesComponent) }],
                changeDetection: ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
IgxPolarScatterSeriesComponent.ctorParameters = () => [];
//# sourceMappingURL=igx-polar-scatter-series-component.js.map