import { OnInit } from "@angular/core";
import { TimeAxisLabelFormat } from "./TimeAxisLabelFormat";
export declare const IgxTimeAxisLabelFormatComponent_PROVIDERS: any[];
export declare class IgxTimeAxisLabelFormatComponent implements OnInit {
    protected _implementation: any;
    readonly i: TimeAxisLabelFormat;
    private onImplementationCreated();
    constructor();
    protected createImplementation(): TimeAxisLabelFormat;
    ngOnInit(): void;
    private _renderer;
    private _provideRenderer(renderer);
    static _createFromInternal(internal: any): IgxTimeAxisLabelFormatComponent;
    /**
 * The visible axis range at which to apply this label format.
*/
    range: number;
    /**
     * The DateTime format string to apply.
     * Some common DateTime format strings are: yyyy, MM/dd/yy, and hh:mm:ss.
    */
    format: string;
    protected _zoneRunner: (act: () => void) => void;
    protected _runInZone(act: () => void): void;
}
