import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { TypeRegistrar } from "igniteui-angular-core/ES2015/type";
import { IgxTimeAxisLabelFormatComponent } from './igx-time-axis-label-format-component';
import { TimeAxisLabelFormat } from './TimeAxisLabelFormat';
import { TimeAxisLabelFormatCollection as TimeAxisLabelFormatCollection_internal } from './TimeAxisLabelFormatCollection';
import { TimeAxisLabelFormatCollection } from './igx-time-axis-label-format-collection';
export class IgxTimeAxisLabelFormatModule {
    constructor() {
        TypeRegistrar.registerCons("IgxTimeAxisLabelFormatComponent", IgxTimeAxisLabelFormatComponent);
        TypeRegistrar.registerCons("IgxTimeAxisLabelFormatCollection", TimeAxisLabelFormatCollection);
        TypeRegistrar.register("TimeAxisLabelFormat", TimeAxisLabelFormat.$type);
        TypeRegistrar.register("TimeAxisLabelFormatCollection", TimeAxisLabelFormatCollection_internal.$type);
    }
}
IgxTimeAxisLabelFormatModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                ],
                declarations: [
                    IgxTimeAxisLabelFormatComponent
                ],
                exports: [
                    IgxTimeAxisLabelFormatComponent
                ],
                entryComponents: [
                    IgxTimeAxisLabelFormatComponent
                ]
            },] },
];
/** @nocollapse */
IgxTimeAxisLabelFormatModule.ctorParameters = () => [];
//# sourceMappingURL=igx-time-axis-label-format-module.js.map