import { Series } from "./Series";
import { NumericXAxis } from "./NumericXAxis";
import { NumericYAxis } from "./NumericYAxis";
import { IFastItemColumn$1 } from "igniteui-angular-core/ES5/IFastItemColumn$1";
import { Color } from "igniteui-angular-core/ES5/Color";
import { Type, Point } from "igniteui-angular-core/ES5/type";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { Axis } from "./Axis";
import { SeriesView } from "./SeriesView";
import { ProgressiveLoadStatusEventArgs } from "./ProgressiveLoadStatusEventArgs";
import { FastItemsSourceEventAction } from "igniteui-angular-core/ES5/FastItemsSourceEventAction";
import { AxisRange } from "./AxisRange";
import { RenderSurface } from "./RenderSurface";
import { RenderingContext } from "igniteui-angular-core/ES5/RenderingContext";
export declare class HighDensityScatterSeries extends Series {
    static $t: Type;
    constructor();
    protected get_c4(): boolean;
    lz: NumericXAxis;
    l1: NumericYAxis;
    nv: string;
    protected l6: IFastItemColumn$1<number>;
    private l5;
    nz: string;
    protected l8: IFastItemColumn$1<number>;
    private l7;
    mf: boolean;
    me: boolean;
    m7: number;
    m6: number;
    os: Color;
    or: Color;
    nj: number;
    private od();
    protected is(a: any, b: string, c: any, d: any): void;
    md(a: any): boolean;
    mc(a: any): boolean;
    private n4(a, b);
    private nd;
    private l9;
    private mt;
    private ms;
    private mr;
    private mq;
    private mp;
    private mo;
    private mw;
    private mv;
    private mu;
    private lx;
    private l2;
    private l3;
    private ly;
    private l0;
    private mb;
    dv(a: Rect, b: Rect, c: SeriesView): boolean;
    private ne;
    nk: number;
    i6(a: boolean): void;
    private n6(a, b);
    private ng;
    private na;
    private m9;
    protected hs(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    private n3(a);
    private n8(a);
    private n7(a);
    progressiveLoadStatusChanged: (sender: any, e: ProgressiveLoadStatusEventArgs) => void;
    private n1(a, b);
    private n5(a);
    private mg;
    private of(a);
    private mm;
    private ml;
    private mn;
    private mz;
    private mx;
    private my;
    private m0;
    private m2;
    private m4;
    private m3;
    private m1;
    private mi;
    private mj;
    private mk;
    private mh;
    private oa(a);
    c8(a: any): boolean;
    private oc(a, b, c, d);
    private nh(a, b);
    private ni(a);
    private m5(a);
    private ob(a, b, c, d, e);
    private n9();
    private nc;
    private nb;
    private lu;
    private nf;
    private n2(a);
    protected bf(): SeriesView;
    im(a: SeriesView): void;
    protected lw: HighDensityScatterSeriesView;
    an(a: Axis): AxisRange;
    private ma;
    protected jk(a: Rect, b: Rect): void;
    protected jl(a: Rect, b: Rect): void;
    private _itemIndexes;
    private lv;
    private ls;
    fm(a: Point): any;
    private nl(a, b);
    oe(a: number[], b: number, c: number): void;
    protected get_dp(): boolean;
    protected set_dp(a: boolean): void;
    hp(a: boolean, b: SeriesView): void;
    i7(a: Rect, b: RenderSurface): void;
    private l4;
    i4(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    hn(): void;
    static $$p: string[];
}
export declare class HighDensityScatterSeriesView extends SeriesView {
    static $t: Type;
    constructor(a: HighDensityScatterSeries);
    ap(): void;
    b7(): void;
    protected bw: HighDensityScatterSeries;
    private bu;
    private b2;
    private b1;
    private bz;
    private b0;
    private bx;
    b3(): void;
    bv(): number[];
    b6(): void;
    b5(a: () => void): void;
    protected a3(a: RenderingContext, b: boolean): void;
    by(a: Color, b: Color): boolean;
    b4(): void;
    ai(a: any): void;
}
