import { CalloutLabelUpdatingEventArgs as CalloutLabelUpdatingEventArgs_internal } from "./CalloutLabelUpdatingEventArgs";
/**
 * Represents event arguments for updating label of callout layer
*/
var /**
 * Represents event arguments for updating label of callout layer
*/
CalloutLabelUpdatingEventArgs = /** @class */ (function () {
    function CalloutLabelUpdatingEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    CalloutLabelUpdatingEventArgs.prototype.createImplementation = function () {
        return new CalloutLabelUpdatingEventArgs_internal();
    };
    Object.defineProperty(CalloutLabelUpdatingEventArgs.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    CalloutLabelUpdatingEventArgs.prototype.onImplementationCreated = function () {
    };
    CalloutLabelUpdatingEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(CalloutLabelUpdatingEventArgs.prototype, "xValue", {
        /**
         * Gets data X-value assositated with callout layer
        */
        get: /**
             * Gets data X-value assositated with callout layer
            */
        function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutLabelUpdatingEventArgs.prototype, "yValue", {
        /**
         * Gets data Y-value assositated with callout layer
        */
        get: /**
             * Gets data Y-value assositated with callout layer
            */
        function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutLabelUpdatingEventArgs.prototype, "item", {
        /**
         * Gets data item assositated with callout layer
        */
        get: /**
             * Gets data item assositated with callout layer
            */
        function () {
            return this.i.item;
        },
        set: function (v) {
            this.i.item = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutLabelUpdatingEventArgs.prototype, "label", {
        /**
         * Gets or sets label displayed by callout layer
        */
        get: /**
             * Gets or sets label displayed by callout layer
            */
        function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = v;
        },
        enumerable: true,
        configurable: true
    });
    return CalloutLabelUpdatingEventArgs;
}());
/**
 * Represents event arguments for updating label of callout layer
*/
export { CalloutLabelUpdatingEventArgs };
//# sourceMappingURL=igx-callout-label-updating-event-args.js.map