import { OnInit } from '@angular/core';
import { ContourValueResolver } from "./ContourValueResolver";
/**
 * Class used to determine the numeric values of contour lines, given a larger list of numeric values.
*/
export declare const IgxContourValueResolverComponent_PROVIDERS: any[];
export declare abstract class IgxContourValueResolverComponent implements OnInit {
    protected createImplementation(): ContourValueResolver;
    ngOnInit(): void;
    protected _implementation: any;
    readonly i: ContourValueResolver;
    private onImplementationCreated();
    constructor();
    protected _zoneRunner: (act: () => void) => void;
    protected _runInZone(act: () => void): void;
}
