/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { InteractivityFactoryManager } from './InteractivityFactoryManager';
import { IgxDoughnutChartDefaultTooltipsComponent } from './igx-doughnut-chart-default-tooltips-component';
import { IgxDVInteractivityModule } from "igniteui-angular-core/ES5/igx-dv-interactivity-module";
var IgxDoughnutChartInteractivityModule = /** @class */ (function () {
    function IgxDoughnutChartInteractivityModule() {
        InteractivityFactoryManager.register();
        IgxDoughnutChartDefaultTooltipsComponent.register();
    }
    IgxDoughnutChartInteractivityModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [IgxDoughnutChartDefaultTooltipsComponent],
                    exports: [IgxDVInteractivityModule],
                    imports: [CommonModule, IgxDVInteractivityModule],
                    entryComponents: [IgxDoughnutChartDefaultTooltipsComponent]
                },] },
    ];
    /** @nocollapse */
    IgxDoughnutChartInteractivityModule.ctorParameters = function () { return []; };
    return IgxDoughnutChartInteractivityModule;
}());
export { IgxDoughnutChartInteractivityModule };
//# sourceMappingURL=igx-doughnut-chart-interactivity-module.js.map