import * as tslib_1 from "tslib";
import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxPolarBaseComponent } from "./igx-polar-base-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { PolarScatterSeries } from "./PolarScatterSeries";
/**
 * Represents a IgxDataChartComponent polar scatter series.
*/
export var IgxPolarScatterSeriesComponent_PROVIDERS = [{ provide: IgxPolarBaseComponent, useExisting: forwardRef(function () { return IgxPolarScatterSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxPolarScatterSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxPolarScatterSeriesComponent; }) }];
var IgxPolarScatterSeriesComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxPolarScatterSeriesComponent, _super);
    function IgxPolarScatterSeriesComponent() {
        return _super.call(this) || this;
    }
    IgxPolarScatterSeriesComponent.prototype.createImplementation = function () {
        return new PolarScatterSeries();
    };
    Object.defineProperty(IgxPolarScatterSeriesComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxPolarScatterSeriesComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-polar-scatter-series',
                    template: "",
                    providers: [{ provide: IgxPolarBaseComponent, useExisting: forwardRef(function () { return IgxPolarScatterSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxPolarScatterSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxPolarScatterSeriesComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxPolarScatterSeriesComponent.ctorParameters = function () { return []; };
    return IgxPolarScatterSeriesComponent;
}(IgxPolarBaseComponent));
export { IgxPolarScatterSeriesComponent };
//# sourceMappingURL=igx-polar-scatter-series-component.js.map