import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxPolarLineSeriesBaseComponent } from "./igx-polar-line-series-base-component";
import { IgxPolarBaseComponent } from "./igx-polar-base-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { PolarSplineAreaSeries } from "./PolarSplineAreaSeries";
/**
 * Represents a IgxDataChartComponent polar spline area series.
*/
export var IgxPolarSplineAreaSeriesComponent_PROVIDERS = [{ provide: IgxPolarLineSeriesBaseComponent, useExisting: forwardRef(function () { return IgxPolarSplineAreaSeriesComponent; }) }, { provide: IgxPolarBaseComponent, useExisting: forwardRef(function () { return IgxPolarSplineAreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxPolarSplineAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxPolarSplineAreaSeriesComponent; }) }];
var IgxPolarSplineAreaSeriesComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxPolarSplineAreaSeriesComponent, _super);
    function IgxPolarSplineAreaSeriesComponent() {
        return _super.call(this) || this;
    }
    IgxPolarSplineAreaSeriesComponent.prototype.createImplementation = function () {
        return new PolarSplineAreaSeries();
    };
    Object.defineProperty(IgxPolarSplineAreaSeriesComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPolarSplineAreaSeriesComponent.prototype, "stiffness", {
        /**
         * Gets or sets the Stiffness property.
        */
        get: /**
             * Gets or sets the Stiffness property.
            */
        function () {
            return this.i.o6;
        },
        set: function (v) {
            this.i.o6 = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgxPolarSplineAreaSeriesComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-polar-spline-area-series',
                    template: "",
                    providers: [{ provide: IgxPolarLineSeriesBaseComponent, useExisting: forwardRef(function () { return IgxPolarSplineAreaSeriesComponent; }) }, { provide: IgxPolarBaseComponent, useExisting: forwardRef(function () { return IgxPolarSplineAreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxPolarSplineAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxPolarSplineAreaSeriesComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxPolarSplineAreaSeriesComponent.ctorParameters = function () { return []; };
    IgxPolarSplineAreaSeriesComponent.propDecorators = {
        "stiffness": [{ type: Input },],
    };
    return IgxPolarSplineAreaSeriesComponent;
}(IgxPolarLineSeriesBaseComponent));
export { IgxPolarSplineAreaSeriesComponent };
//# sourceMappingURL=igx-polar-spline-area-series-component.js.map